package org.ow2.petals.engine.clock;

import java.util.logging.Level;

import javax.jbi.management.DeploymentException;

import org.ow2.petals.component.framework.se.AbstractServiceEngine;

public class Clock extends AbstractServiceEngine {

    private static final String serviceUnit = "serviceUnit";

    private String serviceUnitRootPath;

    private ClockService service;

    private boolean suUndeployed = true;

    public ClockService getService() {
        return this.service;
    }

    @Override
    public void doInit() {
        this.getLogger().info("init Clock service");
        this.service = new ClockService(this.getLogger());
        // serviceUnitRootPath = context.getInstallRoot() + File.separator +
        // "serviceUnit";
    }

    @Override
    public void doStart() {
        this.getLogger().info("start Clock service");
        // if (suUndeployed) {
        // deploySU();
        // }
        // startSU();
    }

    @Override
    public void doStop() {
        this.getLogger().info("stop Clock service");
        // stopSU();
    }

    @Override
    public void doShutdown() {
        this.getLogger().info("shutdown Clock service");
        // undeploySU();
    }

    private void deploySU() {
        try {
            this.getLogger().info("deploy embedded ServiceUnit");
            this.getServiceUnitManager().deploy(serviceUnit, this.serviceUnitRootPath);
            this.getServiceUnitManager().init(serviceUnit, this.serviceUnitRootPath);
            this.suUndeployed = false;
        } catch (DeploymentException e) {
            this.getLogger().log(Level.SEVERE, "Error while deploying the embedded ServiceUnit", e);
        }
    }

    private void undeploySU() {
        try {
            this.getLogger().info("undeploy embedded ServiceUnit");
            this.getServiceUnitManager().undeploy(serviceUnit, this.serviceUnitRootPath);
            this.suUndeployed = true;
        } catch (DeploymentException e) {
            this.getLogger().log(Level.SEVERE, "Error while undeploying the embedded ServiceUnit", e);
        }
    }

    private void startSU() {
        try {
            this.getLogger().info("start embedded ServiceUnit");
            this.getServiceUnitManager().start(serviceUnit);
        } catch (DeploymentException e) {
            this.getLogger().log(Level.SEVERE,
                    "Error while starting the embedded ServiceUnit, undeploy it", e);
            this.undeploySU();
        }
    }

    private void stopSU() {
        try {
            this.getLogger().info("stop embedded ServiceUnit");
            this.getServiceUnitManager().stop(serviceUnit);
        } catch (DeploymentException e) {
            this.getLogger().log(Level.SEVERE,
                    "Error while stopping the embedded ServiceUnit, undeploy it", e);
            this.undeploySU();
        }
    }

}
